on *:SIGNAL:vcmp.command:{

  if ( $vcmp.AdminEnabled == 1 ) {
    var %name = $vcmp.name( $1, $2 )

    if ( $hget( %name, LoggedIn ) ) {
      if ( $vcmp.hash.GetAdminLevel( %name ) > 0 ) !.signal vcmp.adminsys.command $1-
    }
  }
}

on *:SIGNAL:vcmp.command2:{

  if ( $vcmp.AdminEnabled == 1 ) {
    var %name = $vcmp.name( $1, $2 )

    if ( $hget( %name, LoggedIn ) ) {
      if ( $vcmp.hash.GetAdminLevel( %name ) > 0 ) !.signal vcmp.adminsys.command $1-
    }
  }
}

on *:SIGNAL:vcmp.adminsys.command:{
  var %name = $vcmp.name( $1, $2 )

  ; ----- Time Stuff -----
  if ( $3 == morning ) {
    vcmp.say $1 |> Time set to 7:00am <|
    vcmp.settime $1 7 0
  }
  elseif ( $3 == noon ) {
    vcmp.say $1 |> Time set to 12:00pm <|
    vcmp.settime $1 12 0
  }
  elseif ( $3 == evening ) {
    vcmp.say $1 |> Time set to 6:00pm <|
    vcmp.settime $1 18 0
  }
  elseif ( $3 == night ) {
    vcmp.say $1 |> Time set to 9:00pm <|
    vcmp.settime $1 21 0
  }
  elseif ( $3 == midnight ) {
    vcmp.say $1 |> Time set to 12:00am <|
    vcmp.settime $1 0 0
  }

  ; ----- Weather Stuff -----
  elseif ( $3 == rain ) {
    vcmp.say $1 |> Weather changed to: Rain <|
    vcmp.setweather $1 5
  }
  elseif ( $3 == sun ) {
    vcmp.say $1 |> Weather changed to: Sun <|
    vcmp.setweather $1 4
  }
  elseif ( $3 == cloud ) {
    vcmp.say $1 |> Weather changed to: Cloud <|
    vcmp.setweather $1 1
  }
  elseif ( $3 == storm ) {
    vcmp.say $1 |> Weather changed to: Storm <|
    vcmp.setweather $1 2
  }
  elseif ( $3 == fog ) {
    vcmp.say $1 |> Weather changed to: Fog <|
    vcmp.setweather $1 3
  }

  ; ----- Zoning Tools -----
  elseif ( $3 == p ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( zoning ) ) {
      !hadd -m Zoning %name $hget( Zoning, %name ) $+ $chr( 44 ) $+ $round( $vcmp.location( $1, $2 ).x, 4 ) $+ $chr( 44 ) $+ $round( $vcmp.location( $1, $2 ).y, 4 )
      vcmp.msg $1 $2 $iif( $calc( $count( $hget( Zoning, %name ), $chr(44) ) / 2 ) == 1, $v1 point, $v1 points ) set
    }
  }

  elseif ( $3 == clear ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( zoning ) ) {
      if ( $hget( Zoning, %name ) ) {
        !hdel Zoning %name
        vcmp.msg $1 $2 Area Cleared!
      }
      else vcmp.msg $1 $2 You are not currently zoning
    }
  }

  elseif ( $3 == save ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( zoning ) ) {
      if ( $4 ) {
        if ( $hget( Zoning, %name ) ) {
          !hadd CustomAreas $right( $hget( Zoning, %name ), -1 ) $4-
          !hdel Zoning %name
          vcmp.msg $1 $2 Area saved as: $4-
          vcmp.SaveHashes
        }
      }
    }
  }

  elseif ( $3 == ip ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( IP ) ) {
      if ( $4 ) {
        var %a = $iif( $4 isnum, $v1, $vcmp.getid( $1, $4 ) )
        if ( $vcmp.name( $1, %a ) != Unknown ) vcmp.msg $1 $2 |> $vcmp.name( $1, %a ) $+ 's IP: $vcmp.getip( $1, %a ) <|
        else vcmp.msg $1 $2 Error: Invalid Name
      }
      else vcmp.msg $1 $2 |> Your IP: $vcmp.getip( $1, $2 ) <|
    }
  }

  elseif ( $3 == kick ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( kick ) ) {
      if ( $4 ) {
        var %a = $iif( $4 isnum, $v1, $vcmp.getid( $1, $4 ) )
        if ( $vcmp.name( $1, %a ) != Unknown ) {
          if ( $vcmp.hash.GetAdminLevel( %name ) > $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) ) {
            vcmp.say $1 |> $vcmp.name( $1, %a ) has been kicked by %name $+ . ( $+ $iif( $5-, $v1, No Reason ) $+ )
            vcmp.kick $1 %a
          }
          else {
            vcmp.msg $1 $2 Error: You cannot kick an admin of equal or higher level.
            vcmp.msg $1 %a !! Attention! %name has just failed to kick you! !!
          }
        }
        else vcmp.msg $1 $2 Error: Invalid Name
      }
      else vcmp.msg $1 $2 Error: You must say who to kick
    }
  }

  elseif ( $3 == ban ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( ban ) ) {
      if ( $4 ) {
        var %a = $iif( $4 isnum, $v1, $vcmp.getid( $1, $4 ) )
        if ( $vcmp.name( $1, %a ) != Unknown ) {
          if ( $vcmp.hash.GetAdminLevel( %name ) > $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) ) {
            vcmp.say $1 |> $vcmp.name( $1, %a ) has been banned by %name $+ . ( $+ $iif( $5-, $v1, No Reason ) $+ )
            vcmp.ban $1 %a
          }
          else {
            vcmp.msg $1 $2 Error: You cannot ban an admin of equal or higher level.
            vcmp.msg $1 %a !! Attention! %name has just failed to ban you! !!
          }
        }
        else vcmp.msg $1 $2 Error: Invalid Name
      }
      else vcmp.msg $1 $2 Error: You must say who to ban
    }
  }

  elseif ( $3 == set ) {
    if ( $vcmp.hash.GetAdminLevel( %name ) >= $vcmp.command.level( set ) ) {
      if ( $4 ) {
        if ( $4 == admin ) {
          if ( $5 ) {
            if ( ( $6 isnum ) && ( $6 >= 0 ) ) {
              var %a = $iif( $5 isnum, $v1, $vcmp.getid( $1, $5 ) )
              if ( $vcmp.name( $1, %a ) != Unknown ) {
                if ( $vcmp.hash.GetPassword( $vcmp.name( $1, %a ) ) != $null ) {
                  vcmp.say $1 |> $vcmp.name( $1, %a ) has been $iif( $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) > $6, demoted, promoted ) to $iif( $6 == 0, member, level $v1 ) <|
                  vcmp.hash.SetAdminLevel $vcmp.name( $1, %a ) $6
                }
                else vcmp.msg $1 $2 Error: This player is not registered
              }
              else vcmp.msg $1 $2 Error: Invalid name
            }
            else vcmp.msg $1 $2 Error: Invalid admin level
          }
          else vcmp.msg $1 $2 Error: You must say whos level to set
        }

        elseif ( $4 == command ) {
          if ( $5 ) {
            if ( ( $6 isnum ) && ( $6 > 0 ) ) {
              vcmp.msg $1 $2 |> Command level for $5 has been set to $6 <|
              vcmp.command.setlevel $5 $6
            }
            else vcmp.msg $1 $2 Error: Invalid level
          }
          else vcmp.msg $1 $2 Error: You must specify a command
        }

        elseif ( $4 == health ) {
          if ( $5 ) {
            if ( $6 isnum ) {
              var %a = $iif( $5 isnum, $v1, $vcmp.getid( $1, $5 ) )
              if ( $vcmp.name( $1, %a ) != Unknown ) {
                if ( $vcmp.name( $1, %a ) != %name ) {
                  vcmp.msg $1 $2 You have set $vcmp.name( $1, %a ) $+ 's health to: $6 $+ %
                  vcmp.msg $1 %a %name has set your health to: $6 $+ %
                }
                else vcmp.msg $1 $2 You have set your health to: $6 $+ %
                vcmp.sethealth $1 %a $6
              }
              else vcmp.msg $1 $2 Error: Invalid name
            }
            else vcmp.msg $1 $2 Error: Invalid syntax (!set health <player> <health>)
          }
          else vcmp.msg $1 $2 Error: Invalid syntax (!set health <player> <health>)
        }

        elseif ( $4 == armour ) {
          if ( $5 ) {
            if ( $6 isnum ) {
              var %a = $iif( $5 isnum, $v1, $vcmp.getid( $1, $5 ) )
              if ( $vcmp.name( $1, %a ) != Unknown ) {
                if ( $vcmp.name( $1, %a) != %name ) {
                  vcmp.msg $1 $2 You have set $vcmp.name( $1, %a ) $+ 's armour to: $6 $+ %
                  vcmp.msg $1 %a %name has set your armour to: $6 $+ %
                }
                else vcmp.msg $1 $2 You have set your armour to: $6 $+ %
                vcmp.setarmour $1 %a $6
              }
              else vcmp.msg $1 $2 Error: Invalid name
            }
            else vcmp.msg $1 $2 Error: Invalid syntax (!set armour <player> <health>)
          }
          else vcmp.msg $1 $2 Error: Invalid syntax (!set armour <player> <health>)
        }

      }
      else vcmp.msg $1 $2 Error: You must say what to set

    }
  }
}
