;--------------- General VCMP Scripts ---------------- 
;---------------- Created by VRocker -----------------
;---------------- Creation: 01/04/08 -----------------

;--- Initialization ---
on *:LOAD: /vcmp.init
on *:START: /vcmp.init
on *:UNLOAD: /vcmp.destroy

;------ Aliases -------

alias vcmp.LoadHashes {
  if ( $vcmp.AdminEnabled == 1 ) vcmp.loadhash Admins
  if ( $vcmp.Registrations == 1 ) {
    vcmp.loadhash Passwords
    vcmp.loadhash PlayerIPs
  }
  if ( $vcmp.CashSystem == 1 ) {
    vcmp.loadhash Cash
    vcmp.loadhash Bank
    vcmp.loadhash Safe
    vcmp.loadhash Networth
    if ( $vcmp.PropertySystem == 1 ) {
      vcmp.loadhash PropOwners
      vcmp.loadhash PropPrices
      vcmp.loadhash PropNet
      if ( $vcmp.ComSystem == 1 ) vcmp.loadhash PropComs
    }
    if ( $vcmp.VehicleSystem == 1 ) {
      vcmp.loadhash CarOwners
      vcmp.loadhash CarPrices
      vcmp.loadhash CarNet
      if ( $vcmp.ComSystem == 1 ) vcmp.loadhash CarComs
    }
  }

  vcmp.loadhash CustomAreas
  vcmp.loadhash LastSeen

  echo -a -= Hashes Loaded Successfully =-
}

alias vcmp.SaveHashes {
  if ( $vcmp.AdminEnabled == 1 ) !hsave -o Admins VCMP/Hashes/Admins.hsh
  if ( $vcmp.Registrations == 1 ) {
    !hsave -o Passwords VCMP/Hashes/Passwords.hsh
    !hsave -o PlayerIPs VCMP/Hashes/PlayerIPs.hsh
  }
  if ( $vcmp.CashSystem == 1 ) {
    !hsave -o Cash VCMP/Hashes/Cash.hsh
    !hsave -o Bank VCMP/Hashes/Bank.hsh
    !hsave -o Safe VCMP/Hashes/Safe.hsh
    !hsave -o Networth VCMP/Hashes/PlayerIPs.hsh
    if ( $vcmp.PropertySystem == 1 ) {
      !hsave -o PropOwners VCMP/Hashes/PropOwners.hsh
      !hsave -o PropPrices VCMP/Hashes/PropPrices.hsh
      !hsave -o PropNet VCMP/Hashes/PropNet.hsh
      if ( $vcmp.ComSystem == 1 ) !hsave -o PropComs VCMP/Hashes/PropComs.hsh
    }
    if ( $vcmp.VehicleSystem == 1 ) {
      !hsave -o CarOwners VCMP/Hashes/CarOwners.hsh
      !hsave -o CarPrices VCMP/Hashes/CarPrices.hsh
      !hsave -o CarNet VCMP/Hashes/CarNet.hsh
      if ( $vcmp.ComSystem == 1 ) !hsave -o CarComs VCMP/Hashes/CarComs.hsh
    }
  }

  !hsave -o CustomAreas VCMP/Hashes/CustomAreas.hsh

  !hsave -o LastSeen VCMP/Hashes/LastSeen.hsh
}

alias vcmp.FreeHashes {
  if ( $vcmp.AdminEnabled == 1 ) !hfree Admins
  if ( $vcmp.Registrations == 1 ) {
    !hfree Passwords
    !hfree PlayerIPs
  }
  if ( $vcmp.CashSystem == 1 ) {
    !hfree Cash
    !hfree Bank
    !hfree Safe
    !hfree Networth
    if ( $vcmp.PropertySystem == 1 ) {
      !hfree PropOwners
      !hfree PropPrices
      !hfree PropNet
      if ( $vcmp.ComSystem == 1 ) !hfree PropComs
    }
    if ( $vcmp.VehicleSystem == 1 ) {
      !hfree CarOwners
      !hfree CarPrices
      !hfree CarNet
      if ( $vcmp.ComSystem == 1 ) !hfree CarComs
    }
  }

  !hfree CustomAreas

  !hfree LastSeen

  echo -a -= Hashes Freed Successfully =-
}

alias vcmp.loadhash {
  if ( $exists( VCMP/Hashes/ $+ $1 $+ .hsh ) ) {
    !hmake $1 500
    !hload $1 VCMP/Hashes/ $+ $1 $+ .hsh
  }
  else {
    echo -a $time $+ : $1 Not Found - Creating new file named: $1 $+ .hsh!
    !hmake $1 500
    !hsave $1 VCMP/Hashes/ $+ $1 $+ .hsh
  }
}

alias vcmp.init {
  if ( $iif( $vcmp.readini( vcmp.config, Main, Active ), $v1, 1 ) == 1 ) {
    vcmp.LoadHashes
  }
}

alias vcmp.destroy {
  if ( $iif( $vcmp.readini( vcmp.config, Main, Active ), $v1, 1 ) == 1 ) {
    vcmp.SaveHashes
    vcmp.FreeHashes
  }
}

alias vcmp.area {
  var %a = 0, %b = 1, %x = $vcmp.location( $1, $2 ).x, %y = $vcmp.location( $1, $2 ).y
  while ( %b <= $hget( CustomAreas, 0 ).item ) {
    %a = $hget( CustomAreas, %b ).item
    if ( $inpoly( %x, %y, [ %a ] ) ) {
      !return $hget( CustomAreas, %a )
    }
    !inc %b
  }
  !return $vcmp.district( %x, %y )
}

alias vcmp.vehicletype {
  var %model = $vcmp.vehicle( $1, $2 ).model

  if ( ( %model == 166 ) || ( %model == 178 ) || ( %model == 191 ) || ( %model == 192 ) || ( %model == 193 ) || ( %model == 198 ) || ( %model == 199 ) ) !return Bike
  elseif ( (%model == 155 ) || ( %model == 165 ) || ( %model == 177 ) || ( %model == 190 ) || ( %model == 217 ) || ( %model == 218 ) || ( %model == 227 ) ) !return Heli
  elseif ( ( %model == 136 ) || ( %model == 176 ) || ( %model == 182 ) || ( %model == 183 ) || ( %model == 184 ) ||| ( %model == 214 ) ) !return Boat
  else !return Car
}

alias vcmp.doing {
  if ( $vcmp.vehicle( $1, $2 ).name == Unknown ) !return walking
  elseif ( $vcmp.vehicletype( $1, $2 ) == Bike ) !return riding
  elseif ( $vcmp.vehicletype( $1, $2 ) == Heli ) !return flying
  elseif ( $vcmp.vehicletype( $1, $2 ) == Boat ) !return sailing
  else !return driving
}

;--- Configuration Aliases ---
alias vcmp.readini !return $readini( VCMP/INIs/ $+ $1 $+ .ini, $2, $3- )
alias vcmp.writeini writeini VCMP/INIs/ $+ $1 $+ .ini $2 $3 $4-
alias vcmp.AdminEnabled !return $iif( $vcmp.readini( vcmp.config, Config, Admin ), $v1, 0 )
alias vcmp.Registrations !return $iif( $vcmp.readini( vcmp.config, Config, Reg ), $v1, 0 )
alias vcmp.CashSystem !return $iif( $vcmp.readini( vcmp.config, Config, Cash ), $v1, 0 )
alias vcmp.PropertySystem !return $iif( $vcmp.readini( vcmp.config, Config, Property ), $v1, 0 )
alias vcmp.VehicleSystem !return $iif( $vcmp.readini( vcmp.config, Config, Vehicle ), $v1, 0 )

alias vcmp.hash.GetPassword !return $iif( $hget( Passwords, $1 ), $v1, $null )
alias vcmp.hash.GetIP !return $iif( $hget( PlayerIPs, $1 ), $v1, 0.0.0.0 )
alias vcmp.hash.GetAdminLevel !return $iif( $hget( Admins, $1 ), $v1, 0 )
alias vcmp.hash.GetCash !return $iif( $hget( Cash, $1 ) == $null, 0, $v1 )
alias vcmp.hash.GetBank !return $iif( $hget( Bank, $1 ) == $null, 0, $v1 )
alias vcmp.hash.GetNetworth !return $iif( $hget( Networth, $1 ) == $null, 0, $v1 )

alias vcmp.hash.SetCash {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hadd Cash $1 $2
  }
}
alias vcmp.hash.SetBank {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hadd Bank $1 $2
  }
}
alias vcmp.hash.SetNetworth {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hadd Networth $1 $2
  }
}

alias vcmp.hash.IncCash {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hinc Cash $1 $2
  }
}
alias vcmp.hash.IncBank {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hinc Bank $1 $2
  }
}
alias vcmp.hash.IncNetworth {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hinc Networth $1 $2
  }
}

alias vcmp.hash.inc !hinc $1-

alias vcmp.hash.LoadPlayer {
  if ( $vcmp.CashSystem == 1 ) {
    var %cash = $vcmp.hash.GetCash( $3 )
    vcmp.setcash $1 $2 %cash
    !hadd -m $3 Cash %cash
    !hadd -m $3 Bank $vcmp.hash.GetBank( $3 )
    !hadd -m $3 Networth $vcmp.hash.GetNetworth( $3 )
  }
}

alias vcmp.hash.SetPassword !hadd Passwords $1-
alias vcmp.hash.SetAdminLevel !hadd Admins $1-

alias vcmp.hash.SavePlayer {
  if ( $vcmp.CashSystem == 1 ) {
    !hadd Cash $1 $vcmp.player.cash( $1 )
    !hadd Bank $1 $vcmp.player.bank( $1 )
    !hadd Networth $1 $vcmp.player.networth( $1 )

    vcmp.SaveHashes
  }
}

alias vcmp.player.logintries !return $iif( $hget( $1, LoginTries ) == $null, 0, $v1 )
alias vcmp.player.cash !return $iif( $hget( $1, Cash ) == $null, 0, $v1 )
alias vcmp.player.bank !return $iif( $hget( $1, Bank ) == $null, 0, $v1 )
alias vcmp.player.networth !return $iif( $hget( $1, Networth ) == $null, 0, $v1 )

alias vcmp.player.SetCash {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) {
      !hadd -m $1 Cash $2
      vcmp.player.SetNetworth $1 $vcmp.player.calcnetworth( $1 )
    }
  }
}
alias vcmp.player.SetBank {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) {
      !hadd -m $1 Bank $2
      vcmp.player.SetNetworth $1 $vcmp.player.calcnetworth( $1 )
    }
  }
}
alias vcmp.player.SetNetworth {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hadd -m $1 Networth $2
  }
}

alias vcmp.player.IncCash {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) {
      !hinc $1 Cash $2
      vcmp.player.SetNetworth $1 $vcmp.player.calcnetworth( $1 )
    }
  }
}
alias vcmp.player.IncBank {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) {
      !hinc $1 Bank $2
      vcmp.player.SetNetworth $1 $vcmp.player.calcnetworth( $1 )
    }
  }
}
alias vcmp.player.IncNetworth {
  if ( $1 ) {
    if ( ( $2 ) && ( $2 isnum ) ) !hinc $1 Networth $2
  }
}

alias vcmp.player.calcnetworth {
  !return $calc( $vcmp.player.cash( $1 ) + $vcmp.player.bank( $1 ) )
}

alias vcmp.command.level !return $iif( $vcmp.readini( vcmp.commands, Levels, $1- ), $v1, 1 )
alias vcmp.command.setlevel vcmp.writeini vcmp.commands Levels $1-

;--- ...And into the game stuff! ---

on *:SIGNAL:vcmp.join:{
  if ( ( $findtok( admin login register logout help stats showroom, $3, 1, 32 ) ) || ( $vcmp.readini( vcmp.namebanned, banned, $3 ) == 1 ) ) {
    vcmp.msg $1 $2 ATTENTION! This nick is banned! Please change it and rejoin.
    vcmp.kick $1 $2
    !halt
  }

  if ( $vcmp.Registrations ) {
    if ( $vcmp.hash.GetPassword( $3 ) != $null ) {
      if ( $vcmp.ip( $1, $2 ) == $vcmp.hash.GetIP( $1, $2 ) ) {
        if ( $vcmp.AdminEnabled ) {
          if ( $vcmp.hash.GetAdminLevel( $3 ) > 0 ) {
            vcmp.say $1 |> $3 automatically logged in as an admin! ( $+ Level: $vcmp.hash.GetAdminLevel( $3 ) $+ ) <|
            !hadd -m $3 LoggedIn $true
            vcmp.hash.LoadPlayer $1-
            .timerdatasave $+ $2 0 360 vcmp.hash.SavePlayer $3
          }
          else {
            vcmp.say $1 |> $3 automatically logged in as a member <|
            !hadd -m $3 LoggedIn $true
            vcmp.hash.LoadPlayer $1-
            .timerdatasave $+ $2 0 360 vcmp.hash.SavePlayer $3
          }
        }
        else vcmp.say |> $3 automatically logged in as a member <|
      }
      else {
        vcmp.msg $1 $2 The name ' $+ $3 $+ ' is registered. Please login! (/c login <pass>) You have 30 seconds
        .timerlogin $+ $1 1 30 vcmp.kick $1 $2
      }
    }
    else {
      if ( $hget( LastSeen, $3 ) ) {
        vcmp.msg $1 $2 Welcome back to VRPG :)
      }
      else {
        vcmp.msg $1 $2 Welcome to VRPG. Scripts are currently $iif( $iif( $vcmp.readini( vcmp.config, Main, Active ), $v1, 1 ) == 0, offline, online )
        .timer -m 1 25 vcmp.msg $1 $2 To register, please type /c reg <pass>
        if ( $vcmp.CashSystem == 1 ) {
          if ( $vcmp.hash.GetCash( $3 ) == 0 ) vcmp.hash.inc Cash $3 2000
        }
      }
      !hadd -m $3 LoggedIn $true
      vcmp.hash.LoadPlayer $1-
      .timerdatasave $+ $2 0 360 vcmp.hash.SavePlayer $3
    }
  }
  else {
    !hadd -m $3 LoggedIn $true
    vcmp.hash.LoadPlayer $1-
    .timerdatasave $+ $2 0 360 vcmp.hash.SavePlayer $3
  }
  !hadd LastSeen $3 $ctime
}

on *:SIGNAL:vcmp.part:{
  vcmp.hash.SavePlayer $3
  !hfree $3
  .timerdatasave $+ $2 off
}

on *:SIGNAL:vcmp.spawn:{
  if ( $hget( $vcmp.name( $1, $2 ), LoggedIn ) ) {
    var %cash = $vcmp.hash.GetCash(  $vcmp.name( $1, $2 ) )
    vcmp.setcash $1 $2 %cash
  }
}

on *:SIGNAL:vcmp.command2:{
  var %name = $vcmp.name( $1, $2 )

  if ( $3 == login ) {
    if ( $vcmp.registrations ) {
      if ( $vcmp.hash.GetPassword( %name ) != $null ) {
        if ( $hget( %name, LoggedIn ) != $true ) {
          if ( $vcmp.player.logintries( %name ) < 3 ) {
            if ( $4 ) {
              if ( $4 == $vcmp.hash.GetPassword( %name ) ) {
                vcmp.msg $1 $2 Thank you. You are now logged in.
                !hadd -m %name LoggedIn $true
                !hdel %name LoginTries
                vcmp.hash.LoadPlayer $1-2 %name
                .timerlogin $+ $1 off
                .timerdatasave $+ $2 0 360 vcmp.hash.SavePlayer %name

                !hadd PlayerIPs %name $vcmp.getip( $1, $2 )
                vcmp.SaveHashes
              }
              else {
                if ( $vcmp.player.logintries( %name ) == 2 ) {
                  vcmp.say |> Kicking %name $+ ... (Too many invalid passwords) <|
                  vcmp.kick $1 $2
                }
                else {
                  !hinc %name LoginTries 1
                  vcmp.msg $1 $2 Error: You entered an incorrect password. You have $calc( 3 - $vcmp.player.logintries( %name ) ) tries left.
                }
              }
            }
            else vcmp.msg $1 $2 Error: You did not enter a password
          }
          else {
            vcmp.say |> Kicking %name $+ ... (Too many invalid passwords) <|
            vcmp.kick $1 $2
          }
        }
        else vcmp.msg $1 $2 Error: You are already logged in
      }
      else vcmp.msg $1 $2 Error: You are not registered. Please use /c reg <pass>
    }
  }
  elseif ( ( $3 == reg ) || ( $3 == register ) ) {
    if ( $vcmp.registrations ) {
      if ( $vcmp.hash.GetPassword( %name ) == $null ) {
        if ( $4 ) {
          vcmp.msg $1 $2 Thank you. You are now registered. Your password is $4 $+ .
          !hadd Passwords %name $4
          !hadd PlayerIPs %name $vcmp.getip( $1, $2 )
          vcmp.SaveHashes
        }
        else vcmp.msg $1 $2 Error: You did not enter a password
      }
      else vcmp.msg $1 $2 Error: You are already registered. Please login
    }
  }
  elseif ( $3 == logout ) {
    if ( $vcmp.registrations ) {
      if ( $vcmp.hash.GetPassword( %name ) != $null ) {
        if ( $hget( %name, LoggedIn ) == $true ) {
          vcmp.msg $1 $2 You are now logged out.
          vcmp.hash.SavePlayer %name
          !hdel %name LoggedIn
        }
        else vcmp.msg $1 $2 Error: You are not logged in
      }
      else vcmp.msg $1 $2 Error: You are not registered
    }
  }
  elseif ( $3 == changepass ) {
    if ( $vcmp.registrations ) {
      if ( $vcmp.hash.GetPassword( %name ) != $null ) {
        if ( $hget( %name, LoggedIn ) == $true ) {
          if ( $hget( %name, LoginTries ) < 3 ) {
            if ( ( $4 ) && ( $5 ) ) {
              if ( $4 == $vcmp.hash.GetPassword( %name ) ) {
                vcmp.msg $1 $2 You have successfully changed your password from $4 to $5 $+ .
                !hadd Passwords %name $5
                !hdel %name LoginTries
              }
              else {
                vcmp.msg $1 $2 Error: You entered an incorrect old password. You have $calc( $iif( $hget( %name, LoginTries ) == $null, 0, $v1 ) - 3 ) tries left.
                !hinc %name LoginTries 1
              }
            }
            else vcmp.msg $1 $2 Error: Invalid Syntax(/c changepass <oldpass> <newpass>)
          }
          else {
            vcmp.say |> Kicking %name $+ ... (Too many invalid passwords) <|
            vcmp.kick $1 $2
          }
        }
        else vcmp.msg $1 $2 Error: You are not logged in
      }
      else vcmp.msg $1 $2 Error: You are not registered
    }
  }
}

on *:SIGNAL:vcmp.command:{
  var %name = $vcmp.name( $1, $2 )

  if ( $hget( %name, LoggedIn ) ) {
    if ( ( $3 == loc ) || ( $3 == area ) ) {
      if ( $4 ) {
        var %a = $iif( $4 isnum, $v1, $vcmp.getid( $1, $4 ) )
        if ( $vcmp.name( $1, %a ) != Unknown ) vcmp.say $1 |> $vcmp.name( $1, %a ) is currently $vcmp.doing( $1, %a ) $iif( $vcmp.doing( $1, %a ) == flying, over, through ) $vcmp.area( $1, %a ) <|
        else vcmp.msg $1 $2 Error: Invalid name
      }
      else vcmp.say $1 |> %name is currently $vcmp.doing( $1, $2 ) $iif( $vcmp.doing( $1, %a ) == flying, over, through ) $vcmp.area( $1, $2 ) <|
    }

    elseif ( $3 == car ) {
      if ( $4 ) {
        var %a = $iif( $4 isnum, $v1, $vcmp.getid( $1, $4 ) )
        if ( $vcmp.name( $1, %a ) != Unknown ) {
          if ( $vcmp.vehicle( $1, %a ).name == Unknown ) vcmp.say $1 |> $vcmp.name( $1, %a ) is currently on foot. <|
          else vcmp.say $1 |> $vcmp.name( $1, %a ) is currently $vcmp.doing( $1, %a ) a $vcmp.vehicle( $1, %a ).name $+ . (Health: $round( $calc( $vcmp.vehicle( $1, %a ).health / 10 ), 0 ) $+ $chr( 37 ) $+ ) <|
        }
        else vcmp.msg $1 $2 Error: Invalid name
      }
      else {
        if ( $vcmp.vehicle( $1, $2 ).name == Unknown ) vcmp.say $1 |> $vcmp.name( $1, $2 ) is currently on foot. <|
        else vcmp.say $1 |> %name is currently $vcmp.doing( $1, $2 ) a $vcmp.vehicle( $1, $2 ).name $+ . (Health: $round( $calc( $vcmp.vehicle( $1, $2 ).health / 10 ), 0 ) $+ $chr( 37 ) $+ ) <|
      }
    }

    elseif ( $3 == admins ) {
      var %a = 0, %b = 0, %admins
      while ( ( %a < $vcmp.players( $1 ) ) && ( %b < $vcmp.maxplayers( $1 ) ) ) {
        if ( $mta.name( $1, %a ) != Unknown ) {
          if ( $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) > 0 ) {
            if ( $vcmp.readini( vcmp.misc.ini, hidden, $vcmp.name( $1, %a ) ) != 1 ) {
              if ( $vcmp.readini( vcmp.away.ini, away, $vcmp.name( $1, %a ) ) == $null ) {
                if ( $vcmp.idle( $1, %a ) < 300 ) {
                  if ( %admins ) %admins = %admins $+ , $vcmp.name( $1, %a ) $+ $chr( 91 ) $+ $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) $+ $chr( 93 )
                  else %admins = $vcmp.name( $1, %a ) $+ $chr( 91 ) $+ $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) $+ $chr( 93 )
                }
                else {
                  if ( %admins ) %admins = %admins $+ , $vcmp.name( $1, %a ) $+ $chr( 91 ) $+ $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) $+ $chr( 93 ) (Idle: $duration( $vcmp.idle( $1, %a ) ) $+ )
                  else %admins = $vcmp.name( $1, %a ) $+ $chr( 91 ) $+ $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) $+ $chr( 93 ) (Idle: $duration( $vcmp.idle( $1, %a ) ) $+ )
                }
              }
              else {
                if ( %admins ) %admins = %admins $+ , $vcmp.name( $1, %a ) $+ $chr( 91 ) $+ $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) $+ $chr( 93 ) (Away)
                else %admins = $vcmp.name( $1, %a ) $+ $chr( 91 ) $+ $vcmp.hash.GetAdminLevel( $vcmp.name( $1, %a ) ) $+ $chr( 93 ) (Away)
              }
            }
          }
          !inc %b
        }
        !inc %a
      }

      if ( %admins ) vcmp.say $1 |> Current admins: %admins <|
      else vcmp.say $1 |> No admins have been found in the server <|
    }

    elseif ( ( $3 == idle ) || ( $3 == idlers ) ) {
      var %a = 0, %b = 0, %idlers
      while ( ( %a < $vcmp.players( $1 ) ) && ( %b < $vcmp.maxplayers( $1 ) ) ) {
        if ( $mta.name( $1, %a ) != Unknown ) {
          if ( $vcmp.idle( $1, %a ) >= 300 ) {
            if ( %idlers ) %admins = %admins $+ , $vcmp.name( $1, %a ) ( $+ $vcmp.idle( $1, %a ) $+ )
            else %idlers = $vcmp.name( $1, %a ) ( $+ $vcmp.idle( $1, %a ) $+ )
          }
          !inc %b
        }
        !inc %a
      }

      if ( %idlers ) vcmp.say $1 |> Current idlers: %idlers <|
      else vcmp.say $1 |> Nobody is currently idle <|
    }

    elseif ( ( $3 == hp ) || ( $3 == health ) ) {
      if ( $4 ) {
        var %a = $iif( $4 isnum, $v1, $vcmp.getid( $1, $4 ) )
        if ( $vcmp.name( $1, %a ) != Unknown ) {
          if ( $vcmp.health( $1, %a ) == 0 ) vcmp.say |> $vcmp.name( $1, %a ) is dead! <| 
          else vcmp.say $1 |> $vcmp.name( $1, %a ) $+ 's Health: $vcmp.health( $1, %a ) $+ % $iif( $vcmp.armour( $1, %a ) > 0, Armour: $v1 $+ %, $null ) <|
        }
        else vcmp.msg $1 $2 Error: Invalid name
      }
      else {
        if ( $vcmp.health( $1, $2 ) == 0 ) vcmp.say $1 |> %name is dead! <|
        else vcmp.say $1 |> %name $+ 's Health: $vcmp.health( $1, $2 ) $+ % $iif( $vcmp.armour( $1, $2 ) > 0, Armour: $v1 $+ %, $null ) <|
      }
    }

    elseif ( $3 == info ) vcmp.say $1 |> VRockers VC-MP Scripts. Created by: VRocker <|
  }
}
